.include 	"tn2313adef.inc"	;  tiny2313a



.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	Temp6=R22			;  
.def	Temp7=R23			;  ,   
.def	Temp8=R24
.def	Temp9=R25


.dseg					;

OZU: .byte 40				;  40   


;******************************************************************************


.cseg			

.org 0


rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

.org INT0addr				; = 0x0001 External Interrupt Request 0

rjmp INT_0

.org INT_VECTORS_SIZE


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 
					 
				
												 
	ldi Temp,0b11111011		;   "D" (0-, 1-)
	out DDRD,Temp 			; int0   


	RCALL	LCD_INIT		;  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					
;	ldi R16,(1<<ISC00)		;     INT0    
;	out MCUCR,R16
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




	ldi R16,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,R16


	ldi R16,(1<<INT0)		;     INT0
	out GIMSK ,R16


	
	ldi Temp,(1<<cs10)		;    = CK 1:1 ( 1   = 0,05  )
	out TCCR1B,Temp	


	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp

;****************************************

	ldi Temp,(1<<COM0A0)|(1<<wgm01)	;   "OC1A"   (PB3- 15 )
	out TCCR0A,Temp			;   "CTC"

	ldi Temp,(1<<cs01)		;     = CK 1:8
	out TCCR0B,Temp			;   !!!

	LDI R19,0xFF			;     ( dec 15 )
	OUT OCR0A,R19			;       (8-  )

	ldi Temp,0			;   (  8-  )
	out TCNT0,Temp 

;*****************************************

	ldi R22,2			;   ( 1= , 0= , 2=  )

	ldi R23,40			;    ,   



	sei				;   
	

;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;  
;*******************************************************************************

INT_0:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in XL,TCNT1L			;     "X"   "TCNT1"
	in XH,TCNT1H



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp

;______________________________________________________________________________________________________________


	cpi R22,2			;         ?
	brne proverka_flaga_fazy	;  ,     


	ldi R16,(1<<ISC01)		;      "INT0" 
	out MCUCR,R16

	ldi R22,0			;    (0= )


	rjmp out_1			; 





;_______________________________________


proverka_flaga_fazy:

	cpi R22,1			;      ?
	brne setup_rising_edge		;      ,  ...

	
					;        .


setup_falling_edge:			;  - "    "

	ldi R16,(1<<ISC01)		;      "INT0"
	out MCUCR,R16

	ldi R22,0			;    (0= )


	rcall out_disp			;   

loop:
	rjmp loop			; !     "     "




;_______________________________________



					;      ,   

setup_rising_edge:			;  - "    "

	ldi R16,(1<<ISC01)|(1<<ISC00)	;      "INT0"
	out MCUCR,R16

	ldi R22,1			;    (1= )

	rcall out_disp			;   

	rjmp out_1			;   


;**************************************************************************************************************
;      
;**************************************************************************************************************

out_disp:

	mov R16,XH
	swap R16			;        (SWAP -   )
	andi R16, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    

	mov R16,XH
	andi R16, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    


	mov R16,XL
	swap R16			;        (SWAP -   )
	andi R16, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    

	mov R16,XL
	andi R16, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    


	ret 
	


;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	



	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    


;**********************************************************************************************************************

.include "lcd5110mini.asm"		;   		
	
